version 17

/* Converting dates and times stored as strings to 
numeric dates and times */
use visits, clear
describe

list patid admit_str discharge_str, ab(13)

generate admit = date(admit_str, "YMD")
list patid admit 
format admit %td
list patid admit

generate discharge = date(discharge_str, "MDY")
list discharge_str discharge, ab(13)
format discharge %td
list admit_str discharge_str admit discharge, ab(13)

format admit %tdMonth_dd,_ccyy
list admit in 4/5

list admittime_str dischargetime_str, ab(17)

generate double admit_time = clock(admittime_str, "YMDhms")
generate double discharge_time = clock(dischargetime_str, "YMDhm")
list admittime_str dischargetime_str admit_time discharge_time, ab(17)

format %tc admit_time discharge_time
list admit_time discharge_time

list time_str

generate double time = clock(time_str, "hms")
format time %tc 
list time_str time 

format admit_time %tcnn/dd/yy_HH:MM
format discharge_time %tcHH:MM 
list admit_time discharge_time, ab(14)
sort admit_time

generate double admit_Time = Clock(admittime_str, "YMDhms")
format admit_Time %tC 
list admittime_str admit_Time, ab(13)

/* Converting among date types */
generate datefromtime = dofc(admit_time)
list admit_time datefromtime, ab(12)
format datefromtime %td
list admit_time datefromtime, ab(12)

generate mfromdate = mofd(datefromtime)
list datefromtime mfromdate, ab(12)
format mfromdate %tm 
list datefromtime mfromdate, ab(12)

generate monthly = mofd(dofc(admit_time))
format monthly %tm
list admit_time monthly

generate double basictoutc = Cofc(admit_time)
format admit_time basictoutc admit_Time %16.0f
list admit_time basictoutc admit_Time

generate double utctobasic = cofC(admit_Time)
format utctobasic %16.0f
list admit_Time admit_time utctobasic

generate dailyofmonthly = dofm(monthly)
format dailyofmonthly %td 
list monthly dailyofmonthly, ab(14)

generate quarterly = qofd(dofm(monthly))
format quarterly %tq
list monthly quarterly, ab(9)

/* Using dates and times in expressions */
list patid admit if admit > td(01-05-2011)
list patid monthly if monthly > tm(2012-06)

list patid admit if admit > date("May 1, 2011", "MDY")
list patid monthly if monthly > monthly("June 2012", "MY")

/* Computing durations */
use visits2, clear
describe 

generate age = age(birthday,admit)
list birthday admit age

/* This assumes a birthday of March 1st for leaplings 
(those born on Feb. 29) in nonleap years.

If you want their birthday to be observed on Feb. 28 instead, type: */

display isleapyear(2011)
generate age2 = age(birthday,admit,"28feb")
list birthday admit age age2 

generate daysofstay = datediff(admit, discharge, "day")
list admit discharge daysofstay, ab(10)

use epinephrine
describe

list, ab(14)

gen diff = manual_syringe-auto_inject
list auto_inject manual_syringe diff, ab(14)

generate min_diff = clockdiff(auto_inject, manual_syringe,  "minute")
list auto_inject manual_syringe min_diff, ab(14)

// minutes doesn't tell us much here

generate min_frac = clockdiff_frac(auto_inject, manual_syringe, "minute")
list weight auto_inject manual_syringe min_frac, ab(14)

generate sec_diff = clockdiff(auto_inject, manual_syringe, "second")
list patid weight auto_inject manual_syringe sec_diff, ab(14)





